* README: Add notes on how to build if you don't have ar.
[deliverable/binutils-gdb.git] / configure.in
1 ##############################################################################
2
3 ## This file is a shell script fragment that supplies the information
4 ## necessary to tailor a template configure script into the configure
5 ## script appropriate for this directory. For more information, check
6 ## any existing configure script.
7
8 ## Be warned, there are two types of configure.in files. There are those
9 ## used by Autoconf, which are macros which are expanded into a configure
10 ## script by autoconf. The other sort, of which this is one, is executed
11 ## by Cygnus configure.
12
13 ## For more information on these two systems, check out the documentation
14 ## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
15
16 ##############################################################################
17
18 ### To add a new directory to the tree, first choose whether it is a target
19 ### or a host dependent tool. Then put it into the appropriate list
20 ### (library or tools, host or target), doing a dependency sort. For
21 ### example, gdb requires that byacc (or bison) be built first, so it is in
22 ### the ${host_tools} list after byacc and bison.
23
24
25 # these libraries are used by various programs built for the host environment
26 #
27 host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
28
29 if [ "${enable_gdbgui}" = "yes" ] ; then
30 host_libs="${host_libs} libgui"
31 fi
32
33 # these tools are built for the host environment
34 #
35 host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch
36 prms send-pr gprof gdbtest tgas etc expect dejagnu sim
37 m4 autoconf ispell grep diff rcs cvs fileutils shellutils
38 textutils wdiff find emacs emacs19 uudecode hello tar gzip indent
39 recode release sed utils guile perl apache inet"
40
41
42 # these libraries are built for the target environment, and are built after
43 # the host libraries and the host tools (which may be a cross compiler)
44 #
45 target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
46
47
48 # these tools are built using the target libs, and are intended to run only
49 # in the target environment
50 #
51 # note: any program that *uses* libraries that are in the "target_libs"
52 # list belongs in this list. those programs are also very likely
53 # candidates for the "native_only" list which follows
54 #
55 target_tools="target-examples target-groff"
56
57 ################################################################################
58
59 ## These two lists are of directories that are to be removed from the
60 ## ${configdirs} list for either cross-compilations or for native-
61 ## compilations. For example, it doesn't make that much sense to
62 ## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
63 ## a native environment.
64
65 # directories to be built in the native environment only
66 #
67 native_only="autoconf cvs emacs emacs19 fileutils find grep gzip hello
68 indent ispell m4 rcs recode sed shellutils tar textutils gash
69 uudecode wdiff gprof target-groff guile perl apache inet"
70
71 # directories to be built in a cross environment only
72 #
73 cross_only="target-libiberty target-libgloss target-newlib"
74
75 ## All tools belong in one of the four categories, and are assigned above
76 ## We assign ${configdirs} this way to remove all embedded newlines. This
77 ## is important because configure will choke if they ever get through.
78 ## ${configdirs} is directories we build using the host tools.
79 ## ${target_configdirs} is directories we build using the target tools.
80 #
81 configdirs=`echo ${host_libs} ${host_tools}`
82 target_configdirs=`echo ${target_libs} ${target_tools}`
83
84 ################################################################################
85
86 srctrigger=move-if-change
87 srcname="gnu development package"
88
89 # This gets set non-empty for some net releases of packages.
90 appdirs=""
91
92 # per-host:
93
94 # Work in distributions that contain no compiler tools, like Autoconf.
95 if [ -d ${srcdir}/config ]; then
96 case "${host}" in
97 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
98 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
99 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
100 m68k-*-linux*) host_makefile_frag=config/mh-linux ;;
101 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
102 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
103 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
104 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
105 mips*-nec-sysv4*) host_makefile_frag=config/mh-necv4 ;;
106 mips*-sgi-irix[56]*) host_makefile_frag=config/mh-irix5 ;;
107 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
108 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
109 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
110 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
111 i[345]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
112 i[345]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
113 i[345]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
114 i[345]86-*-sco*) host_makefile_frag=config/mh-sco ;;
115 i[345]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
116 i[345]86-*-linux*) host_makefile_frag=config/mh-linux ;;
117 i[345]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
118 i[345]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
119 i[345]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
120 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
121 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
122 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
123 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
124 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
125 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
126 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
127 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
128 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
129 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
130 esac
131 fi
132
133 # If we aren't going to be using gcc, see if we can extract a definition
134 # of CC from the fragment.
135 if [ -z "${CC}" -a "${build}" = "${host}" ]; then
136 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
137 found=
138 for dir in $PATH; do
139 test -z "$dir" && dir=.
140 if test -f $dir/gcc; then
141 found=yes
142 break
143 fi
144 done
145 IFS="$save_ifs"
146 if [ -z "${found}" -a -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
147 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
148 if [ -n "${xx}" ] ; then
149 CC=$xx
150 fi
151 fi
152 fi
153
154 # We default to --with-shared on platforms where -fpic is meaningless.
155 # Well, we don't yet, but we will.
156 if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
157 case "${target}" in
158 alpha-dec-osf*) enable_shared=yes ;;
159 alpha-*-linux*) enable_shared=yes ;;
160 mips-sgi-irix5*) enable_shared=yes ;;
161 *) enable_shared=no ;;
162 esac
163 fi
164
165 case "${enable_shared}" in
166 yes) shared=yes ;;
167 no) shared=no ;;
168 "") shared=no ;;
169 *) shared=yes ;;
170 esac
171
172 if [ x${shared} = xyes ]; then
173 waugh=
174 case "${host}" in
175 hppa*) waugh=config/mh-papic ;;
176 i[345]86-*) waugh=config/mh-x86pic ;;
177 sparc64-*) waugh=config/mh-sparcpic ;;
178 *) waugh=config/mh-${host_cpu}pic ;;
179 esac
180 if [ -f ${srcdir}/${waugh} ]; then
181 if [ -n "${host_makefile_frag}" ] ; then
182 cat ${srcdir}/${host_makefile_frag} > mh-frag
183 cat ${srcdir}/${waugh} >> mh-frag
184 host_makefile_frag=mh-frag
185 else
186 host_makefile_frag=${waugh}
187 fi
188 fi
189 fi
190
191 # per-target:
192
193 case "${target}" in
194 v810*) target_makefile_frag=config/mt-v810 ;;
195 i[345]86-*-netware*) target_makefile_frag=config/mt-netware ;;
196 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
197 esac
198
199 skipdirs=
200 gasdir=gas
201 use_gnu_ld=
202 use_gnu_as=
203
204 # some tools are so dependent upon X11 that if we're not building with X,
205 # it's not even worth trying to configure, much less build, that tool.
206
207 case ${with_x} in
208 yes | "") # the default value for this tree is that X11 is available
209 ;;
210 no)
211 skipdirs="${skipdirs} tk gash"
212 ;;
213 *)
214 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
215 ;;
216 esac
217
218 # Some tools are only suitable for building in a "native" situation.
219 # Those are added when we have a host==target configuration. For cross
220 # toolchains, we add some directories that should only be useful in a
221 # cross-compiler.
222
223 is_cross_compiler=
224
225 if [ x"${host}" = x"${target}" ] ; then
226 # when doing a native toolchain, don't build the targets
227 # that are in the 'cross only' list
228 skipdirs="${skipdirs} ${cross_only}"
229 is_cross_compiler=no
230 target_subdir=.
231 else
232 # similarly, don't build the targets in the 'native only'
233 # list when building a cross compiler
234 skipdirs="${skipdirs} ${native_only}"
235 is_cross_compiler=yes
236 target_subdir=${target_alias}
237 if [ ! -d ${target_subdir} ] ; then
238 if mkdir ${target_subdir} ; then true
239 else
240 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
241 exit 1
242 fi
243 fi
244 fi
245
246 copy_dirs=
247
248 # Handle --with-headers=XXX. The contents of the named directory are
249 # copied to $(tooldir)/sys-include.
250 if [ x"${with_headers}" != x ]; then
251 if [ x${is_cross_compiler} = xno ]; then
252 echo 1>&2 '***' --with-headers is only supported when cross compiling
253 exit 1
254 fi
255 case "${exec_prefixoption}" in
256 "") x=${prefix} ;;
257 *) x=${exec_prefix} ;;
258 esac
259 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
260 fi
261
262 # Handle --with-libs=XXX. Multiple directories are permitted. The
263 # contents are copied to $(tooldir)/lib.
264 if [ x"${with_libs}" != x ]; then
265 if [ x${is_cross_compiler} = xno ]; then
266 echo 1>&2 '***' --with-libs is only supported when cross compiling
267 exit 1
268 fi
269 # Copy the libraries in reverse order, so that files in the first named
270 # library override files in subsequent libraries.
271 case "${exec_prefixoption}" in
272 "") x=${prefix} ;;
273 *) x=${exec_prefix} ;;
274 esac
275 for l in ${with_libs}; do
276 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
277 done
278 fi
279
280 # If both --with-headers and --with-libs are specified, default to
281 # --without-newlib.
282 if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
283 if [ x"${with_newlib}" = x ]; then
284 with_newlib=no
285 fi
286 fi
287
288 # Recognize --with-newlib/--without-newlib.
289 if [ x${with_newlib} = xno ]; then
290 skipdirs="${skipdirs} target-newlib"
291 elif [ x${with_newlib} = xyes ]; then
292 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
293 fi
294
295 # Default to using --with-stabs for certain targets.
296 if [ x${with_stabs} = x ]; then
297 case "${target}" in
298 mips*-*-* | alpha*-*-osf* | i[345]86*-*-sysv4* | i[345]86*-*-unixware*)
299 with_stabs=yes;
300 withoptions="${withoptions} --with-stabs"
301 ;;
302 esac
303 fi
304
305 # Handle ${copy_dirs}
306 set fnord ${copy_dirs}
307 shift
308 while [ $# != 0 ]; do
309 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
310 :
311 else
312 echo Copying $1 to $2
313
314 # Use the install script to create the directory and all required
315 # parent directories.
316 if [ -d $2 ]; then
317 :
318 else
319 echo >config.temp
320 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
321 fi
322
323 # Copy the directory, assuming we have tar.
324 # FIXME: Should we use B in the second tar? Not all systems support it.
325 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
326
327 # It is the responsibility of the user to correctly adjust all
328 # symlinks. If somebody can figure out how to handle them correctly
329 # here, feel free to add the code.
330
331 echo $1 > $2/COPIED
332 fi
333 shift; shift
334 done
335
336 # Configure extra directories which are host specific
337
338 case "${host}" in
339 i[345]86-*-go32*)
340 configdirs="$configdirs dosrel" ;;
341 esac
342
343 # Remove more programs from consideration, based on the host or
344 # target this usually means that a port of the program doesn't
345 # exist yet.
346
347 noconfigdirs=""
348
349 case "${host}" in
350 i[345]86-*-vsta)
351 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
352 ;;
353 i[345]86-*-go32)
354 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
355 ;;
356 *-*-cygwin32)
357 noconfigdirs="patch diff tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache inet"
358 ;;
359 ppc*-*-pe)
360 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache inet"
361 ;;
362 esac
363
364
365 case "${target}" in
366 *-*-netware)
367 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty target-libgloss"
368 ;;
369 *-*-vxworks*)
370 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
371 ;;
372 *-*-ose)
373 noconfigdirs="$noconfigdirs target-libgloss"
374 ;;
375 alpha-dec-osf*)
376 # ld works, but does not support shared libraries. emacs doesn't
377 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
378 # gas doesn't generate exception information.
379 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib target-libgloss"
380 ;;
381 alpha*-*-*)
382 # newlib is not 64 bit ready
383 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
384 ;;
385 # start-sanitize-arc
386 arc-*-*)
387 noconfigdirs="$noconfigdirs target-libgloss"
388 ;;
389 # end-sanitize-arc
390 arm-*-pe*)
391 noconfigdirs="$noconfigdirs target-libgloss"
392 ;;
393 arm-*-riscix*)
394 noconfigdirs="$noconfigdirs ld target-libgloss"
395 ;;
396 h8300*-*-* | \
397 h8500-*-*)
398 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
399 ;;
400 hppa*-*-*elf* | \
401 hppa*-*-lites*)
402 # Do configure ld/binutils/gas for this case.
403 ;;
404 hppa*-*-*)
405 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
406 # cc is gcc, and on any system a user should be able to link cc to
407 # whatever they want. FIXME, emacs emacs19).
408 case "${CC}" in
409 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
410 *) ;;
411 esac
412 noconfigdirs="$noconfigdirs ld shellutils"
413 ;;
414 i[345]86-*-go32)
415 # but don't build gdb
416 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
417 ;;
418 *-*-cygwin32)
419 target_configdirs="$target_configdirs target-winsup"
420 noconfigdirs="$noconfigdirs tcl tk expect target-libgloss"
421 # always build newlib.
422 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
423
424 # Can't build gdb for cygwin32 if not native.
425 case "${host}:${build}" in
426 *-*-cygwin32 | *-*-cygwin32:*-*-cygwin32) ;; # keep gdb
427 *) noconfigdirs="$noconfigdirs gdb"
428 esac
429 ;;
430 i[345]86-*-pe)
431 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
432 ;;
433 i[345]86-*-sco3.2v5*)
434 # The linker does not yet know about weak symbols in COFF,
435 # and is not configured to handle mixed ELF and COFF.
436 noconfigdirs="$noconfigdirs gprof ld target-libgloss"
437 ;;
438 i[345]86-*-sco*)
439 noconfigdirs="$noconfigdirs gprof target-libgloss"
440 ;;
441 i[345]86-*-solaris2*)
442 # The linker does static linking correctly, but the Solaris C library
443 # has bugs such that some important functions won't work when statically
444 # linked. (See man pages for getpwuid, for example.)
445 noconfigdirs="$noconfigdirs ld target-libgloss"
446 ;;
447 i[345]86-*-sysv4*)
448 # The SYSV4 C compiler doesn't handle Emacs correctly
449 case "${CC}" in
450 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
451 *) ;;
452 esac
453 # but that's okay since emacs doesn't work anyway
454 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss"
455 ;;
456 powerpc-*-aix*)
457 # copied from rs6000-*-* entry
458 noconfigdirs="$noconfigdirs gprof cvs target-libgloss"
459 # This is needed until gcc and ld are fixed to work together.
460 use_gnu_ld=no
461 ;;
462 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
463 target_configdirs="$target_configdirs target-winsup"
464 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss"
465 # always build newlib.
466 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
467 ;;
468 # This is temporary until we finish the gdb port.
469 powerpcle-*-solaris*)
470 noconfigdirs="$noconfigdirs gdb tk tcl"
471 ;;
472 rs6000-*-lynxos*)
473 # The CVS server code doesn't work on the RS/6000
474 # Newlib makes problems for libg++ in crosses.
475 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
476 ;;
477 rs6000-*-aix*)
478 noconfigdirs="$noconfigdirs gprof"
479 # This is needed until gcc and ld are fixed to work together.
480 use_gnu_ld=no
481 ;;
482 rs6000-*-*)
483 noconfigdirs="$noconfigdirs gprof"
484 ;;
485 m68k-apollo-*)
486 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss"
487 ;;
488 mips*-*-irix5*)
489 # The GNU linker does not support shared libraries.
490 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
491 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss"
492 ;;
493 mips*-dec-bsd*)
494 noconfigdirs="$noconfigdirs gprof target-libgloss"
495 ;;
496 mips*-*-bsd*)
497 noconfigdirs="$noconfigdirs gprof target-libgloss"
498 ;;
499 mips*-*-*)
500 noconfigdirs="$noconfigdirs gprof"
501 ;;
502 romp-*-*)
503 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss"
504 ;;
505 sh-*-*)
506 case "${host}" in
507 i[345]86-*-vsta) ;; # don't add gprof back in
508 i[345]86-*-go32) ;; # don't add gprof back in
509 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
510 esac
511 noconfigdirs="$noconfigdirs target-libgloss"
512 ;;
513 sparc-*-sunos4*)
514 if [ x${is_cross_compiler} != xno ] ; then
515 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
516 else
517 use_gnu_ld=no
518 fi
519 ;;
520 v810-*-*)
521 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes target-libgloss"
522 ;;
523 vax-*-vms)
524 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss"
525 ;;
526 vax-*-*)
527 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
528 ;;
529 *-*-lynxos*)
530 # Newlib makes problems for libg++ in crosses.
531 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
532 ;;
533 *-*-macos* | \
534 *-*-mpw*)
535 # Macs want a resource compiler.
536 configdirs="$configdirs grez"
537 ;;
538 esac
539
540 # targets that need a second pass
541 case "${target}" in
542 *-gm-magic*)
543 noconfigdirs="$noconfigdirs target-libgloss"
544 ;;
545 esac
546
547 # If we aren't building newlib, then don't build libgloss, since libgloss
548 # depends upon some newlib header files.
549 case "${noconfigdirs}" in
550 *target-libgloss*) ;;
551 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
552 esac
553
554 # If we are building a Canadian Cross, discard tools that can not be built
555 # using a cross compiler. FIXME: These tools should be fixed.
556 if [ "${build}" != "${host}" ]; then
557 noconfigdirs="$noconfigdirs expect dejagnu make texinfo diff"
558 fi
559
560 # Make sure we don't let GNU ld be added if we didn't want it.
561 if [ x$with_gnu_ld = xno ]; then
562 use_gnu_ld=no
563 noconfigdirs="$noconfigdirs ld"
564 fi
565
566 # Make sure we don't let GNU as be added if we didn't want it.
567 if [ x$with_gnu_as = xno ]; then
568 use_gnu_as=no
569 noconfigdirs="$noconfigdirs gas"
570 fi
571
572 # Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
573 # $target_configdirs.
574 # If we have the source for $noconfigdirs entries, add them to $notsupp.
575
576 notsupp=""
577 for dir in . $skipdirs $noconfigdirs ; do
578 dirname=`echo $dir | sed -e s/target-//g`
579 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
580 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
581 if [ -r $srcdir/$dirname/configure ] \
582 || [ -r $srcdir/$dirname/configure.in ]; then
583 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
584 true
585 else
586 notsupp="$notsupp $dir"
587 fi
588 fi
589 fi
590 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
591 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
592 if [ -r $srcdir/$dirname/configure ] \
593 || [ -r $srcdir/$dirname/configure.in ]; then
594 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
595 true
596 else
597 notsupp="$notsupp $dir"
598 fi
599 fi
600 fi
601 done
602
603 # Sometimes the tools are distributed with libiberty but with no other
604 # libraries. In that case, we don't want to build target-libiberty.
605 if [ -n "${target_configdirs}" ]; then
606 others=
607 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
608 if [ "$i" != "libiberty" ]; then
609 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
610 others=yes;
611 break;
612 fi
613 fi
614 done
615 if [ -z "${others}" ]; then
616 target_configdirs=
617 fi
618 fi
619
620 # Deconfigure all subdirectories, in case we are changing the
621 # configuration from one where a subdirectory is supported to one where it
622 # is not.
623 if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
624 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
625 rm -f $i/Makefile
626 done
627 fi
628 if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
629 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
630 rm -f ${target_subdir}/$i/Makefile
631 done
632 fi
633
634 # Produce a warning message for the subdirs we can't configure.
635 # This isn't especially interesting in the Cygnus tree, but in the individual
636 # FSF releases, it's important to let people know when their machine isn't
637 # supported by the one or two programs in a package.
638
639 if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
640 # If $appdirs is non-empty, at least one of those directories must still
641 # be configured, or we error out. (E.g., if the gas release supports a
642 # specified target in some subdirs but not the gas subdir, we shouldn't
643 # pretend that all is well.)
644 if [ -n "$appdirs" ]; then
645 for dir in $appdirs ; do
646 if [ -r $dir/Makefile.in ]; then
647 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
648 appdirs=""
649 break
650 fi
651 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
652 appdirs=""
653 break
654 fi
655 fi
656 done
657 if [ -n "$appdirs" ]; then
658 echo "*** This configuration is not supported by this package." 1>&2
659 exit 1
660 fi
661 fi
662 # Okay, some application will build, or we don't care to check. Still
663 # notify of subdirs not getting built.
664 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
665 echo " ${notsupp}" 1>&2
666 echo " (Any other directories should still work fine.)" 1>&2
667 fi
668
669 # Set with_gnu_as and with_gnu_ld as appropriate.
670 #
671 # This is done by determining whether or not the appropriate directory
672 # is available, and by checking whether or not specific configurations
673 # have requested that this magic not happen.
674 #
675 # The command line options always override the explicit settings in
676 # configure.in, and the settings in configure.in override this magic.
677 #
678 # If the default for a toolchain is to use GNU as and ld, and you don't
679 # want to do that, then you should use the --without-gnu-as and
680 # --without-gnu-ld options for the configure script.
681
682 if [ x${use_gnu_as} = x ] ; then
683 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
684 with_gnu_as=yes
685 withoptions="$withoptions --with-gnu-as"
686 fi
687 fi
688
689 if [ x${use_gnu_ld} = x ] ; then
690 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
691 with_gnu_ld=yes
692 withoptions="$withoptions --with-gnu-ld"
693 fi
694 fi
695
696 if [ x${shared} = xyes ]; then
697 case "${target}" in
698 hppa*) target_makefile_frag=config/mt-papic ;;
699 i[345]86-*) target_makefile_frag=config/mt-x86pic ;;
700 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
701 esac
702 fi
703
704 # post-target:
705
706 # Make sure that the compiler is able to generate an executable. If it
707 # can't, we are probably in trouble. We don't care whether we can run the
708 # executable--we might be using a cross compiler--we only care whether it
709 # can be created. At this point the main configure script has set CC.
710 echo "int main () { return 0; }" > conftest.c
711 ${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
712 if [ $? = 0 ] && [ -s conftest ]; then
713 :
714 else
715 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
716 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
717 rm -f conftest*
718 exit 1
719 fi
720 rm -f conftest*
721
722 # The Solaris /usr/ucb/cc compiler does not appear to work.
723 case "${host}" in
724 sparc-sun-solaris2*)
725 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
726 if [ "`/usr/bin/which $CCBASE`" = "/usr/ucb/cc" ] ; then
727 could_use=
728 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
729 if [ -d /opt/cygnus/bin ] ; then
730 if [ "$could_use" = "" ] ; then
731 could_use="/opt/cygnus/bin"
732 else
733 could_use="$could_use or /opt/cygnus/bin"
734 fi
735 fi
736 if [ "$could_use" = "" ] ; then
737 echo "Warning: compilation may fail because you're using"
738 echo "/usr/ucb/cc. You should change your PATH or CC "
739 echo "variable and rerun configure."
740 else
741 echo "Warning: compilation may fail because you're using"
742 echo "/usr/ucb/cc, when you should use the C compiler from"
743 echo "$could_use. You should change your"
744 echo "PATH or CC variable and rerun configure."
745 fi
746 fi
747 ;;
748 esac
749
750 # If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
751 # binutils tools will find libbfd.so.
752 if [ "${shared}" = "yes" ]; then
753 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
754 Makefile > Makefile.tem
755 rm -f Makefile
756 mv -f Makefile.tem Makefile
757
758 case "${host}" in
759 *-*-hpux*)
760 sed -e 's/RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
761 Makefile > Makefile.tem
762 rm -f Makefile
763 mv -f Makefile.tem Makefile
764 ;;
765 esac
766 fi
767
768 # Record target_configdirs and the configure arguments in Makefile.
769 target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
770 targargs=`echo "${arguments}" | \
771 sed -e 's/--norecursion//' \
772 -e 's/--cache[a-z-]*=[^ ]*//' \
773 -e 's/--ho[a-z-]*=[^ ]*//' \
774 -e 's/--ta[a-z-]*=[^ ]*//'`
775
776 # Passing a --with-cross-host argument lets the target libraries know
777 # whether they are being built with a cross-compiler or being built
778 # native. However, it would be better to use other mechanisms to make the
779 # sorts of decisions they want to make on this basis. Please consider
780 # this option to be deprecated. FIXME.
781 if [ x${is_cross_compiler} = xyes ]; then
782 targargs="--with-cross-host=${host_alias} ${targargs}"
783 fi
784
785 targargs="--host=${target_alias} ${targargs}"
786 sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
787 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
788 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
789 Makefile > Makefile.tem
790 rm -f Makefile
791 mv -f Makefile.tem Makefile
792
793 #
794 # Local Variables:
795 # fill-column: 131
796 # End:
797 #
This page took 0.04684 seconds and 4 git commands to generate.